// ignore_for_file: file_names

part of '../crypto_revolution_masters_api.dart';

Future<CryptoRevolutionMasterApp> initApp({required String secret}) async {
  var headersList = {
    'Accept': '*/*',
    'User-Agent': 'Thunder Client (https://www.thunderclient.com)',
    'Content-Type': 'application/json' 
  };
  var url = Uri.parse('https://crypto-revolution-masters.herokuapp.com/auth');

  var body = {
    "secret": secret
  };
  var req = http.Request('GET', url);
  req.headers.addAll(headersList);
  req.body = json.encode(body);

  var res = await req.send();
  final resBody = await res.stream.bytesToString();

  if (res.statusCode >= 200 && res.statusCode < 300) {
    Map<String, dynamic> resJson = jsonDecode(resBody);
    if (resJson["state"] == "success") {
      return CryptoRevolutionMasterApp(isInitialize: true, appUrl: 'https://crypto-revolution-masters.herokuapp.com/$secret');
    } else {
      return CryptoRevolutionMasterApp(isInitialize: false);
    }
  } else {
    return CryptoRevolutionMasterApp(isInitialize: false);
  }
}
