part of '../crypto_revolution_masters_api.dart';

Stream<List<CoinModel>> coin({required CryptoRevolutionMasterApp cryptoRevolutionMasterApp}) async* {
  StreamController<List<CoinModel>> controller = StreamController();
  if (cryptoRevolutionMasterApp.isInitialize) {
    int statusCode = 0;

    dynamic resBody;

    Timer.periodic(const Duration(minutes: 1), (timer) async {
      var headersList = {
        'Accept': '*/*',
      };
      var url = Uri.parse('${cryptoRevolutionMasterApp.appUrl}/coins');

      var req = http.Request('GET', url);
      req.headers.addAll(headersList);

      var res = await req.send();

      statusCode = res.statusCode;

      resBody = await res.stream.bytesToString();

      if (statusCode != 0) {
        if (statusCode >= 200 && statusCode < 300) {
          Map<String, dynamic> data = json.decode(resBody);
          if (data.containsKey("data")) {
            List<CoinModel> filteredData = List.empty(growable: true);
            for (var element in (data["data"] as List<dynamic>)) { 
              filteredData.add(
                CoinModel(
                  name: element["name"], 
                  symbol: element["symbol"], 
                  image: element["image"], 
                  current_price: element["current_price"], 
                  market_cap: element["market_cap"], 
                  market_cap_rank: element["market_cap_rank"], 
                  fully_diluted_valuation: element["fully_diluted_valuation"], 
                  market_cap_change_24h: element["market_cap_change_24h"], 
                  ath_change_percentage: element["ath_change_percentage"], 
                  market_cap_change_percentage_24h: element["market_cap_change_percentage_24h"], 
                  high_24h: element["high_24h"], 
                  low_24h: element["low_24h"]
                )
              );
            }
            controller.sink.add(filteredData);
          } else {
            controller.sink.addError(ResponseErrorMessage.backendError);
          }
        } else if (statusCode > 300 && statusCode <= 400) {
          controller.sink.addError(ResponseErrorMessage.noInternetConnection);
        }
        else {
         controller.sink.addError(ResponseErrorMessage.backendError);
        }
      }
    });

    var headersList = {
      'Accept': '*/*',
    };
    var url = Uri.parse('${cryptoRevolutionMasterApp.appUrl}/coins');

    var req = http.Request('GET', url);
    req.headers.addAll(headersList);

    var res = await req.send();

    statusCode = res.statusCode;

    resBody = await res.stream.bytesToString();

    if (statusCode != 0) {
      if (statusCode >= 200 && statusCode < 300) {
        Map<String, dynamic> data = json.decode(resBody);
        if (data.containsKey("data")) {
          List<CoinModel> filteredData = List.empty(growable: true);
            for (var element in (data["data"] as List<dynamic>)) { 
              filteredData.add(
                CoinModel(
                  name: element["name"], 
                  symbol: element["symbol"], 
                  image: element["image"], 
                  current_price: element["current_price"], 
                  market_cap: element["market_cap"], 
                  market_cap_rank: element["market_cap_rank"], 
                  fully_diluted_valuation: element["fully_diluted_valuation"], 
                  market_cap_change_24h: element["market_cap_change_24h"], 
                  ath_change_percentage: element["ath_change_percentage"], 
                  market_cap_change_percentage_24h: element["market_cap_change_percentage_24h"], 
                  high_24h: element["high_24h"], 
                  low_24h: element["low_24h"]
                )
              );
            }
            controller.sink.add(filteredData);
        } else {
          controller.sink.addError(ResponseErrorMessage.backendError);
        }
      } else if (statusCode > 300 && statusCode <= 400) {
        controller.sink.addError(ResponseErrorMessage.noInternetConnection);
      }
      else {
        controller.sink.addError(ResponseErrorMessage.backendError);
      }
    } else {
      controller.sink.addError(ResponseErrorMessage.backendError);
    }
  } else {
    controller.sink.addError(ResponseErrorMessage.invalidedSecret);
  }

  yield* controller.stream;
}